package dev.shadowsoffire.apotheosis.spawn;

import java.util.HashSet;
import org.apache.logging.log4j.LogManager;
import net.minecraft.ResourceLocationException;
import dev.shadowsoffire.placebo.config.Configuration;
import java.io.File;
import net.minecraftforge.event.entity.EntityTeleportEvent;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.phys.Vec3;
import net.minecraft.world.entity.Mob;
import net.minecraftforge.event.entity.living.LivingEvent;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.item.SpawnEggItem;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import dev.shadowsoffire.apotheosis.spawn.enchantment.CapturingEnchant;
import net.minecraft.world.item.enchantment.Enchantment;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerModifier;
import net.minecraft.world.item.crafting.RecipeSerializer;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerItem;
import net.minecraft.world.item.Item;
import dev.shadowsoffire.placebo.util.PlaceboUtil;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerBlock;
import net.minecraft.world.level.block.Block;
import dev.shadowsoffire.placebo.registry.RegistryEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import dev.shadowsoffire.apotheosis.spawn.compat.SpawnerTOPPlugin;
import net.minecraftforge.fml.ModList;
import net.minecraft.world.level.ItemLike;
import dev.shadowsoffire.placebo.tabs.TabFillingRegistry;
import net.minecraft.world.item.CreativeModeTabs;
import net.minecraft.resources.ResourceKey;
import net.minecraft.world.item.Items;
import dev.shadowsoffire.apotheosis.Apotheosis;
import com.google.common.collect.ImmutableSet;
import net.minecraft.world.level.block.Blocks;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraftforge.eventbus.api.EventPriority;
import java.util.function.Consumer;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraft.resources.ResourceLocation;
import java.util.Set;
import org.apache.logging.log4j.Logger;

public class SpawnerModule
{
    public static final Logger LOG;
    public static int spawnerSilkLevel;
    public static int spawnerSilkDamage;
    public static Set<ResourceLocation> bannedMobs;
    public static boolean enableCapturingEnchantmentJeiInfo;
    
    @SubscribeEvent
    public void setup(final FMLCommonSetupEvent e) {
        MinecraftForge.EVENT_BUS.addListener((Consumer)this::dropsEvent);
        MinecraftForge.EVENT_BUS.addListener((Consumer)this::handleUseItem);
        MinecraftForge.EVENT_BUS.addListener((Consumer)this::reload);
        MinecraftForge.EVENT_BUS.addListener((Consumer)this::handleTooltips);
        MinecraftForge.EVENT_BUS.addListener((Consumer)this::tickDumbMobs);
        MinecraftForge.EVENT_BUS.addListener(EventPriority.HIGH, (Consumer)this::dumbMobsCantTeleport);
        e.enqueueWork(() -> {
            BlockEntityType.f_58925_.f_58914_ = ApothSpawnerTile::new;
            BlockEntityType.f_58925_.f_58915_ = (Set)ImmutableSet.of((Object)Blocks.f_50085_);
            this.reload(null);
            TabFillingRegistry.registerSimple((ItemLike)Items.f_42007_, new ResourceKey[] { CreativeModeTabs.f_256869_ });
            if (ModList.get().isLoaded("theoneprobe")) {
                SpawnerTOPPlugin.register();
            }
        });
    }
    
    @SubscribeEvent
    public void blocks(final RegistryEvent.Register<Block> e) {
        final ApothSpawnerBlock spawner = new ApothSpawnerBlock();
        PlaceboUtil.overrideStates(Blocks.f_50085_, (Block)spawner);
        e.getRegistry().register((Object)spawner, new ResourceLocation("minecraft", "spawner"));
    }
    
    @SubscribeEvent
    public void items(final RegistryEvent.Register<Item> e) {
        e.getRegistry().register((Object)new ApothSpawnerItem(), new ResourceLocation("minecraft", "spawner"));
    }
    
    @SubscribeEvent
    public void serializers(final RegistryEvent.Register<RecipeSerializer<?>> e) {
        e.getRegistry().register((Object)SpawnerModifier.SERIALIZER, "spawner_modifier");
    }
    
    @SubscribeEvent
    public void enchants(final RegistryEvent.Register<Enchantment> e) {
        e.getRegistry().register((Object)new CapturingEnchant(), "capturing");
    }
    
    public void dropsEvent(final LivingDropsEvent e) {
        ((CapturingEnchant)Apoth.Enchantments.CAPTURING.get()).handleCapturing(e);
    }
    
    public void handleUseItem(final PlayerInteractEvent.RightClickBlock e) {
        if (e.getLevel().m_7702_(e.getPos()) instanceof ApothSpawnerTile) {
            final ItemStack s = e.getItemStack();
            final Item 41720_ = s.m_41720_();
            if (41720_ instanceof final SpawnEggItem egg) {
                final EntityType<?> type = (EntityType<?>)egg.m_43228_(s.m_41783_());
                if (SpawnerModule.bannedMobs.contains(EntityType.m_20613_((EntityType)type))) {
                    e.setCanceled(true);
                }
            }
        }
    }
    
    public void handleTooltips(final ItemTooltipEvent e) {
        final ItemStack s = e.getItemStack();
        final Item 41720_ = s.m_41720_();
        if (41720_ instanceof final SpawnEggItem egg) {
            final EntityType<?> type = (EntityType<?>)egg.m_43228_(s.m_41783_());
            if (SpawnerModule.bannedMobs.contains(EntityType.m_20613_((EntityType)type))) {
                e.getToolTip().add(Component.m_237115_("misc.apotheosis.banned").m_130940_(ChatFormatting.GRAY));
            }
        }
    }
    
    public void tickDumbMobs(final LivingEvent.LivingTickEvent e) {
        final LivingEntity entity = e.getEntity();
        if (entity instanceof final Mob mob) {
            if (!mob.m_9236_().f_46443_ && mob.m_21525_() && mob.getPersistentData().m_128471_("apotheosis:movable")) {
                mob.m_21557_(false);
                mob.m_7023_(new Vec3((double)mob.f_20900_, (double)mob.f_20902_, (double)mob.f_20901_));
                mob.m_21557_(true);
            }
        }
    }
    
    public void dumbMobsCantTeleport(final EntityTeleportEvent e) {
        if (e.getEntity().getPersistentData().m_128471_("apotheosis:movable")) {
            e.setCanceled(true);
        }
    }
    
    public void reload(final Apotheosis.ApotheosisReloadEvent e) {
        final Configuration config = new Configuration(new File(Apotheosis.configDir, "spawner.cfg"));
        config.setTitle("Apotheosis Spawner Module Configuration");
        SpawnerModule.spawnerSilkLevel = config.getInt("Spawner Silk Level", "general", 1, -1, 127, "The level of silk touch needed to harvest a spawner.  Set to -1 to disable, 0 to always drop.  The enchantment module can increase the max level of silk touch.\nFunctionally server-authoritative, but should match on client for information.");
        SpawnerModule.spawnerSilkDamage = config.getInt("Spawner Silk Damage", "general", 100, 0, 100000, "The durability damage dealt to an item that silk touches a spawner.\nServer-authoritative.");
        SpawnerModule.bannedMobs.clear();
        final String[] stringList;
        final String[] bans = stringList = config.getStringList("Banned Mobs", "spawn_eggs", new String[0], "A list of entity registry names that cannot be applied to spawners via egg.\nShould match between client and server.");
        for (final String s : stringList) {
            try {
                SpawnerModule.bannedMobs.add(new ResourceLocation(s));
            }
            catch (final ResourceLocationException ex) {
                SpawnerModule.LOG.error("Invalid entry {} detected in the spawner banned mobs list.", (Object)s);
                ex.printStackTrace();
            }
        }
        SpawnerModule.enableCapturingEnchantmentJeiInfo = config.getBoolean("Enable Capturing Enchantment JEI Info", "general", true, "Whether to show info regarding the capturing enchantment in the JEI information for spawn eggs.");
        if (e == null && config.hasChanged()) {
            config.save();
        }
    }
    
    static {
        LOG = LogManager.getLogger("Apotheosis : Spawner");
        SpawnerModule.spawnerSilkLevel = 1;
        SpawnerModule.spawnerSilkDamage = 100;
        SpawnerModule.bannedMobs = new HashSet<ResourceLocation>();
        SpawnerModule.enableCapturingEnchantmentJeiInfo = true;
    }
}
